/**
 *  @file eglplus/doc.hpp
 *  @brief Documentation-only declarations
 *
 *  @author Matus Chochlik
 *
 *  Copyright 2012-2013 Matus Chochlik. Distributed under the Boost
 *  Software License, Version 1.0. (See accompanying file
 *  LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 */

#pragma once
#ifndef EGLPLUS_DOC_1303201501_HPP
#define EGLPLUS_DOC_1303201501_HPP

#include <eglplus/config.hpp>

#if EGLPLUS_DOCUMENTATION_ONLY

/// All definitions of EGLplus are nested in the eglplus namespace
namespace eglplus {

/** @mainpage EGLplus - a C++ wrapper for EGL®
 *
 *  @image html eglplus.png
 *
 *  EGLplus is a header-only library which implements
 *  a thin object-oriented facade over the EGL® (version 1.4)
 *  C-language API. It provides wrappers which automate
 *  resource and object management and make the use of EGL native platform
 *  interface in C++ safer and easier.

 *  - @ref eglplus_getting_started
 *
 *  It is currently distributed as a part of
 *  <A HREF="../../oglplus/html/index.html">OGLplus</A>.

 *  @section eglplus_getting_started Getting started
 *
 *  One of the best ways how to get yourself acquainted with the library is to
 *  look at the examples and to browse through the reference.
 */

} // namespace eglplus
#endif // EGLPLUS_DOCUMENTATION_ONLY

#endif // include guard
