/**
 *  @file oalplus/doc.hpp
 *  @brief Documentation-only declarations
 *
 *  @author Matus Chochlik
 *
 *  Copyright 2012-2013 Matus Chochlik. Distributed under the Boost
 *  Software License, Version 1.0. (See accompanying file
 *  LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 */

#pragma once
#ifndef OALPLUS_DOC_1303201501_HPP
#define OALPLUS_DOC_1303201501_HPP

#include <oalplus/config.hpp>

#if OALPLUS_DOCUMENTATION_ONLY

/// All definitions of OALplus are nested in the oalplus namespace
namespace oalplus {

/** @mainpage OALplus - a C++ wrapper for OpenAL® version 1.1.
 *
 *  @image html oalplus.png
 *
 *  OALplus is a header-only library which implements
 *  a thin object-oriented facade over the OpenAL® (version 1.1)
 *  C-language API. It provides wrappers which automate
 *  resource and object management and make the use of OpenAL
 *  in C++ safer and easier.

 *  - @ref oalplus_getting_started
 *    - @ref oalplus_tutorials
 *
 *  It is currently distributed as a part of
 *  <A HREF="../../oglplus/html/index.html">OGLplus</A>.

 *  @section oalplus_getting_started Getting started
 *
 *  One of the best ways how to get yourself acquainted with the library is to
 *  look at the examples and to browse through the reference. Many of the examples
 *  are thoroughly commented and for some of them step-by-step
 *  @ref oalplus_tutorials "tutorials" are being added. Some of the standalone
 *  examples show the usage of @OALplus with @OGLplus.
 */

} // namespace oglplus
#endif // OALPLUS_DOCUMENTATION_ONLY

#endif // include guard
