/*
 *  .file doc/tutorial/oglplus/index.cpp
 *
 *  .author Matus Chochlik
 *
 *  Copyright 2010-2013 Matus Chochlik. Distributed under the Boost
 *  Software License, Version 1.0. (See accompanying file
 *  LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 */

#if OGLPLUS_DOCUMENTATION_ONLY

/** @page oglplus_tutorials Tutorials
 *
 *  This section contains tutorials explaining step-by-step the usage of @OGLplus.
 *  Many of these tutorials are based on the examples that come with @OGLplus,
 *  and like the examples, some show complete standalone applications and some only
 *  go through the code (usually encapsulated in a class that is derived from
 *  the @c oglplus::Example class) that is directly related to the usage
 *  of @OGLplus, ommitting the parts
 *  related to window system initialization, OpenGL initialization and
 *  processing of events.
 *
 *  Generally the tutorials assume that the reader has some programming
 *  skills and experience with C++. The first tutorials also try to explain
 *  how rendering with OpenGL works, what the individual resources like
 *  shaders, programs, vertex arrays, textures, etc. are used for in an OpenGL
 *  application, but the more advanced tutorials expect that the reader
 *  is acquainted with the basic concepts and with the workings of the OpenGL
 *  rendering pipeline, which were explained in the earlier tutorials.
 *
 *  - @subpage oglplus_tut_000_build_lib
 *  - @subpage oglplus_tut_001_glut_glew
 *  - @subpage oglplus_tut_002_rgb_triangle
 *  - @subpage oglplus_tut_004_newton_fractal
 *  - @subpage oglplus_tut_004_rect
 */

#endif // OGLPLUS_DOCUMENTATION_ONLY
