/**
 *  @file oglplus/all.hpp
 *  @brief All-in-one inclusion of everything in OGLplus
 *
 *  @author Matus Chochlik
 *
 *  Copyright 2010-2014 Matus Chochlik. Distributed under the Boost
 *  Software License, Version 1.0. (See accompanying file
 *  LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 */

#pragma once
#ifndef OGLPLUS_ALL_1107121519_HPP
#define OGLPLUS_ALL_1107121519_HPP

#include <oglplus/fwd.hpp>

#include <oglplus/string/ref_ios.hpp>

#include <oglplus/math/angle.hpp>
#include <oglplus/math/vector.hpp>
#include <oglplus/math/quaternion.hpp>
#include <oglplus/math/matrix.hpp>
#include <oglplus/math/plane.hpp>
#include <oglplus/math/curve.hpp>
#include <oglplus/math/sphere.hpp>

#include <oglplus/error/object.hpp>
#include <oglplus/error/prog_var.hpp>
#include <oglplus/error/program.hpp>

#include <oglplus/context.hpp>

#include <oglplus/data_type.hpp>
#include <oglplus/primitive_type.hpp>

#include <oglplus/uniform.hpp>
#include <oglplus/dsa/uniform.hpp>
#include <oglplus/uniform_block.hpp>
#include <oglplus/uniform_subroutines.hpp>
#include <oglplus/vertex_attrib.hpp>
#include <oglplus/frag_data.hpp>

#include <oglplus/shader_storage_block.hpp>

#include <oglplus/vertex_array.hpp>
#include <oglplus/buffer.hpp>
#include <oglplus/texture.hpp>
#include <oglplus/sampler.hpp>
#include <oglplus/framebuffer.hpp>
#include <oglplus/renderbuffer.hpp>
#include <oglplus/transform_feedback.hpp>
#include <oglplus/program_pipeline.hpp>
#include <oglplus/query.hpp>
#include <oglplus/program.hpp>
#include <oglplus/shader.hpp>
#include <oglplus/sync.hpp>

#include <oglplus/named_string.hpp>

#include <oglplus/object/group.hpp>
#include <oglplus/object/array.hpp>
#include <oglplus/object/optional.hpp>

#include <oglplus/prog_var/typechecked.hpp>
#include <oglplus/prog_var/optional.hpp>
#include <oglplus/prog_var/lazy.hpp>

#include <oglplus/extension.hpp>

#endif // include guard
