/**
 *  @file oglplus/pixel_data.hpp
 *  @brief Pixel data-related declarations
 *
 *  @author Matus Chochlik
 *
 *  Copyright 2010-2015 Matus Chochlik. Distributed under the Boost
 *  Software License, Version 1.0. (See accompanying file
 *  LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 */

#pragma once
#ifndef OGLPLUS_PIXEL_DATA_1107121519_HPP
#define OGLPLUS_PIXEL_DATA_1107121519_HPP

#include <oglplus/enums/pixel_data_type.hpp>
#include <oglplus/enums/pixel_data_format.hpp>
#include <oglplus/enums/pixel_data_internal_format.hpp>
#include <oglplus/enums/image_unit_format.hpp>

namespace oglplus {

/// Alias for PixelDataFormat
/**
 *  @ingroup enumerations
 */
typedef PixelDataFormat Format;

/// Alias for PixelDataInternalFormat
/**
 *  @ingroup enumerations
 */
typedef PixelDataInternalFormat InternalFormat;

} // namespace oglplus

#endif // include guard
